#ifndef BI_CG_S_SOLVER_H
#define BI_CG_S_SOLVER_H

#include <Eigen/Eigen>
#include <Eigen/Sparse>
#include <vector>

#include "integrator_2d.h"
#include "setting.h"

class BiCGSSolver : public Integrator2D {
public:
  BiCGSSolver(){};
  ~BiCGSSolver(){};
  void IntegrateForward(const std::vector<Adv_Tensor_Type>& Adv_tensor,
                        const Eigen::VectorXd & coefficients_old,
                        const double dt,
                        Eigen::VectorXd* coefficients_new,
                        double* condition_number_,
                        float* contraction_time,
                        float* solver_time) override;
protected:
};

#endif
